<?php
require 'constants.php';
require 'header.php';

echo "  <h1>Administrator: Add DKP From Raid</h1>\n";

if (stripslashes($_POST['instance']) == '' || stripslashes($_POST['date']) == '' || stripslashes($_POST['note']) == '') {
	echo "  <p class=\"error\">Some required fields were not filled out.</p>
		<p class=\"goback\">Return to the <a href=\"add-raid.php\">Add Raid</a> page.</p>";
}
else if (verifyPassword($db, stripslashes($_POST['password']), array(PERM_MODIFY_DKP => TRUE))) {
	begin($db);

	/* First we determine a unique ID for the new entry. */

	$result = pg_query($db, "SELECT MAX(raid_id) FROM Raids;");
	if (!$result) { echo "  <p class\"error\">Could not obtain a unique raid ID: " . pg_last_error($db); require 'footer.php'; exit; }
	if (pg_num_rows($result)) {
		// if there is at least one entry, the unique ID is 1 + the highest existing ID
		$row = pg_fetch_row($result);
		if ($row[0] == NULL) $raidID = 0; // otherwise start at zero
		else $raidID = $row[0] + 1;
	}
	else { echo "  <p class\"error\">Querying the maximum raid ID for Raids unexpectedly returned no rows.</p>\n"; require 'footer.php'; exit; }

	/* Add the entry to the Raids table. */

	$query = "INSERT INTO Raids (raid_id,instance,date,note) VALUES (" . pg_escape_string($raidID) . ",'" . pg_escape_string(stripslashes($_POST['instance'])) . "','" . pg_escape_string(stripslashes($_POST['date'])) . "','" . pg_escape_string(stripslashes($_POST['note'])) . "');";
	$result = pg_query($db, $query);
	if (!$result) { echo "  <p class=\"error\">Could not add to Raids table: " . pg_last_error($db); require 'footer.php'; exit; }

	/* Add a DKP entry for every participating player. */

	// determine first change id that's free to use
	$result = pg_query($db, "SELECT MAX(change_id) FROM DKP;");
	if (!$result) { echo "  <p class\"error\">Could not obtain a unique change ID: " . pg_last_error($db); require 'footer.php'; exit; }
	if (pg_num_rows($result)) {
		// if there is at least one entry, the unique ID is 1 + the highest existing ID
		$row = pg_fetch_row($result);
		if ($row[0] == NULL) $changeID = 0; // otherwise start at zero
		else $changeID = $row[0] + 1;
	}
	else { echo "  <p class\"error\">Querying the maximum change ID for DKP unexpectedly returned no rows.</p>\n"; require 'footer.php'; exit; }
	// get list of players
	$namesResult = pg_query($db, "SELECT name FROM Players ORDER BY name ASC;");
	if (!$namesResult) { echo "  <p class=\"error\">Could not query list of players from Players table: " . pg_last_error($db); require 'footer.php'; exit; }
	// add dkp for each player
	while ($row = pg_fetch_row($namesResult)) {
		$curName = $row[0];
		if (stripslashes($_POST["dkp-$curName"]) == 0) continue; // don't bother adding an entry if no DKP is added

		// determine the next change id
		while (!$uniqueID) {
			$result = pg_query($db, "SELECT change_id FROM DKP WHERE change_id = " . pg_escape_string($changeID) . ";");
			if (!$result) { echo "  <p class=\"error\">Could not check a change ID in the DKP table: " . pg_last_error($db); require 'footer.php'; exit; }
			if (pg_num_rows($result) == 0) break;
			$changeID++;
		}

		$query = "INSERT INTO DKP (change_id,raid_id,amount,name) VALUES (" . pg_escape_string($changeID) . ", " . pg_escape_string($raidID) . ", " . pg_escape_string(stripslashes($_POST["dkp-$curName"])) . ", '" . pg_escape_string($curName) . "');";
		$result = pg_query($db, $query);
		if (!$result) { echo "  <p class=\"error\">Could not add " . $curName . "'s DKP entry: " . pg_last_error($db); require 'footer.php'; exit; }

		$changeID++; // increment it here to optimize the previous while loop later
	}

	commit($db);
	echo "  <p>DKP successfully updated to reflect the new " . stripslashes($_POST['instance']) . " run.</p>
		<p class=\"goback\">Return to the <a href=\"index.php\">Player List</a>.</p>";
}
else {
	echo "  <p class=\"error\">The supplied administrator password was incorrect.</p>
		<p class=\"goback\">Return to the <a href=\"add-raid.php\">Add Raid</a> page.</p>";
}

require 'footer.php';
?>
