<?php
require 'constants.php';
require 'constants-dkpvalues.php';
require 'header.php';

echo "  <h1>Administrator: Add Raid From File</h1>\n";

if (!verifyPassword($db, stripslashes($_POST['password']), array(PERM_MODIFY_DKP => TRUE))) {
	echo "  <p class=\"error\">The supplied administrator password was incorrect.</p>
		<p class=\"goback\">Return to the <a href=\"lua-choosefile.php\">Add Raid From File</a> page.</p>";
	require 'footer.php';
	exit;
}

echo "  <p>I am now adding the raids you selected to the DKP website. Note that if there is an error at any point during this process, <i>none</i> of the raids will be added, despite what any of the messages below say. (That way, once the problem is fixed, you can simply upload the whole file again and not worry about adding a raid twice.) However, if the process completes without errors, all of your raids will be in the system.</p>\n";

begin($db);
$luaRaids = unserialize(urldecode(stripslashes($_POST['lua-data'])));
echo "<ul class=\"progress\">\n";
foreach ($luaRaids as $currentRaid) {
	$logFileName = tempnam('/tmp/', 'lua-logtmp');
	if (!$logFile = fopen($logFileName, 'w')) { echo "  </ul>\n<p class=\"error\">Could not open the Lua log file $logFileName</p>\n"; rollback($db); require 'footer.php'; exit; }

	if (stripslashes($_POST['include-' . $currentRaid[1]['time']])) {
		$ontimeBonusAddedYet = false;
		$instanceName = $currentRaid[1]['data']['instance'];
		$instanceDate = date('Y-m-d', strtotime($currentRaid[1]['time']));
		$dkpEarnings = array();
		$raidID = 0;

		echo "<li><b>Adding the $instanceDate raid on $instanceName</b></li>\n<ul>\n";

		if (!fwrite($logFile, "RAID ON $instanceName AT $instanceDate\n")) { echo "  </ul>\n<p class=\"error\">Could not write to the log file.<\p>\n"; rollback($db); require 'footer.php'; exit; }
		foreach ($currentRaid as $currentEvent) {
			if ($currentEvent['event'] == 'INST') {
				echo "<li>Determining raid ID... ";
				/* First we determine a unique ID for the new entry. */

				$result = pg_query($db, "SELECT MAX(raid_id) FROM Raids;");
				if (!$result) { echo "  </ul>\n<p class\"error\">Could not obtain a unique raid ID: " . pg_last_error($db); require 'footer.php'; exit; }
				if (pg_num_rows($result)) {
					// if there is at least one entry, the unique ID is 1 + the highest existing ID
					$row = pg_fetch_row($result);
					if ($row[0] == NULL) $raidID = 0; // otherwise start at zero
					else $raidID = $row[0] + 1;
				}
				else { echo "  </ul>\n<p class\"error\">Querying the maximum raid ID for Raids unexpectedly returned no rows.</p>\n"; rollback($db); require 'footer.php'; exit; }
				echo "$raidID</li>\n";

				/* Add the entry to the Raids table. */

				$query = "INSERT INTO Raids (raid_id,instance,date,note) VALUES (" . pg_escape_string($raidID) . ",'" . pg_escape_string($instanceName) . "','" . pg_escape_string($instanceDate) . "','" . pg_escape_string(stripslashes($_POST['note-' . $currentRaid[1]['time']])) . "');";
				$result = pg_query($db, $query);
				if (!$result) { echo "  </ul>\n<p class=\"error\">Could not add to Raids table: " . pg_last_error($db); require 'footer.php'; exit; }
				
				if (!fwrite($logFile, "Raid given ID $raidID and note \"" . stripslashes($_POST['note-' . $currentRaid]) . "\"\n")) { echo "  </ul>\n<p class=\"error\">Could not write to the log file.<\p>\n"; rollback($db); require 'footer.php'; exit; }
			}
			if ($currentEvent['event'] == 'POKE') {
				foreach ($currentEvent['data']['members'] as $currentMember) {
					if ($dkpEarnings[$currentMember] == null) { $dkpEarnings[$currentMember] = 0; }
					$dkpEarnings[$currentMember] += $DKP_PER_HOUR[$instanceName] / $POKES_PER_HOUR;

					if (!fwrite($logFile, "$currentMember POKE +" . $DKP_PER_HOUR[$instanceName] / $POKES_PER_HOUR . "\n")) { echo "  </ul>\n<p class=\"error\">Could not write to the log file.<\p>\n"; rollback($db); require 'footer.php'; exit; }
				}
			}
			if ($currentEvent['event'] == 'ONTIME') {
				foreach ($currentEvent['data']['members'] as $currentMember) {
					if ($dkpEarnings[$currentMember] == null) { $dkpEarnings[$currentMember] = 0; }
					$dkpEarnings[$currentMember] += $ONTIME_BONUS[$instanceName];

					if (!fwrite($logFile, "$currentMember ONTIME +" . $ONTIME_BONUS[$instanceName] . "\n")) { echo "  </ul>\n<p class=\"error\">Could not write to the log file.<\p>\n"; rollback($db); require 'footer.php'; exit; }
				}
			}
			if ($currentEvent['event'] == 'BOSS') {
				foreach ($currentEvent['data']['members'] as $currentMember) {
					if ($dkpEarnings[$currentMember] == null) { $dkpEarnings[$currentMember] = 0; }
					$dkpEarnings[$currentMember] += $BOSS_DKP_VALUE[$currentEvent['data']['boss']];

					if (!fwrite($logFile, "$currentMember BOSS \"" . $currentEvent['data']['boss'] . "\" +" . $BOSS_DKP_VALUE[$currentEvent['data']['boss']] . "\n")) { echo "  </ul>\n<p class=\"error\">Could not write to the log file.<\p>\n"; rollback($db); require 'footer.php'; exit; }
				}
			}
			if ($currentEvent['event'] == 'ATTEMPT') {
				foreach ($currentEvent['data']['members'] as $currentMember) {
					if ($dkpEarnings[$currentMember] == null) { $dkpEarnings[$currentMember] = 0; }
					$dkpEarnings[$currentMember] += $BOSS_ATTEMPT_DKP_VALUE[$currentEvent['data']['boss']];

					if (!fwrite($logFile, "$currentMember ATTEMPT \"" . $currentEvent['data']['boss'] . "\" +" . $BOSS_ATTEMPT_DKP_VALUE[$currentEvent['data']['boss']] . "\n")) { echo "  </ul>\n<p class=\"error\">Could not write to the log file.<\p>\n"; rollback($db); require 'footer.php'; exit; }
				}
			}
			if ($currentEvent['event'] == 'LOOT') {
				echo "<li>Handling loot...</li>\n<ul>\n";
				
				/* First we determine a unique ID for the new entry. */
				echo "<li>Determining ID... ";

				$result = pg_query($db, "SELECT MAX(change_id) FROM DKP;");
				if (!$result) { echo "  </ul>\n<p class\"error\">Could not obtain a unique change ID: " . pg_last_error($db); require 'footer.php'; exit; }
				if (pg_num_rows($result)) {
					// if there is at least one entry, the unique ID is 1 + the highest existing ID
					$row = pg_fetch_row($result);
					if ($row[0] == NULL) $changeID = 0; // otherwise start at zero
					else $changeID = $row[0] + 1;
				}
				else { echo "  </ul>\n<p class\"error\">Querying the maximum change_id for DKP unexpectedly returned no rows.</p>\n"; rollback($db); require 'footer.php'; exit; }
				echo "$changeID</li>\n";

				/* Create an entry in the Players table if we need to. */
				
				$player = $currentEvent['data']['winner'];
				$result = pg_query($db, "SELECT name FROM Players WHERE name='" . pg_escape_string($player) . "';");
				if (!$result) { echo "  </ul>\n<p class=\"error\">Could not check if a player already existed: " . pg_last_error($db); require 'footer.php'; exit; }
				if (pg_num_rows($result) == 0) {
					$result = pg_query($db, "INSERT INTO Players (name, active) VALUES ('" . pg_escape_string($player) . "', FALSE);");
					if (!$result) { echo "  </ul>\n<p class=\"error\">Could not add an inactive player: " . pg_last_error($db); require 'footer.php'; exit; }
				}

				/* Now insert the DKP deduction into the DKP table. */
				echo "<li>Recording to database... ";

				$query = "INSERT INTO DKP (change_id,raid_id,amount,name) VALUES (" . pg_escape_string($changeID) . "," . pg_escape_string($raidID) . "," . pg_escape_string($currentEvent['data']['bid']) . ",'" . pg_escape_string($currentEvent['data']['winner']) . "');";
				$result = pg_query($db, $query);
				if (!$result) { echo "  </ul>\n<p class=\"error\">Could not insert a new DKP entry for the winning bid: " . pg_last_error($db); require 'footer.php'; exit; }

				/* Record the item won in the Items table, if necessary. */

				$item = $currentEvent['data']['item'];
				$query = "SELECT * FROM Items WHERE item='" . pg_escape_string($item) . "';";
				$result = pg_query($db, $query);
				if (!$result) { echo "  </ul>\n<p class=\"error\">Could not query Items table to determine if the item \"" . $item . "\" is already in the table: " . pg_last_error($db); require 'footer.php'; exit; }
				if (pg_num_rows($result) == 0) {
					// it's not in the table, add it
					$url = "http://www.thottbot.com/?s=" . urlencode($item);
					$query = "INSERT INTO Items (item, url) VALUES ('" . pg_escape_string($item) . "', '" . pg_escape_string($url) . "');";
					$result = pg_query($db, $query);
					if (!$result) { echo "  </ul>\n<p class=\"error\">Could not create new <code>Items</code> entry for the item \"" . $item . "\": " . pg_last_error($db); require 'footer.php'; exit; }
				}

				/* Record an entry in the Bids table corresponding to the entry in the DKP table, and associate it with the item won in the Items table. */

				$query = "INSERT INTO Bids (change_id, item) VALUES (" . pg_escape_string($changeID) . ", '" . pg_escape_string($item) . "');";
				$result = pg_query($db, $query);
				if (!$result) { echo "  </ul>\n<p class=\"error\">Could not add the <code>Bids</code> entry for the item \"" . $item . "\": " . pg_last_error($db); require 'footer.php'; exit; }

				if (!fwrite($logFile, $currentEvent['data']['winner'] . ' LOOT "' . $currentEvent['data']['item'] . '" -' . $currentEvent['data']['bid'] . "\n")) { echo "  </ul>\n<p class=\"error\">Could not write to the log file.<\p>\n"; rollback($db); require 'footer.php'; exit; }
				echo "done</li>\n</ul>\n";
			}
		} 

		echo "<li>Adding DKP credits...</li>\n<ul>\n";
		foreach ($dkpEarnings as $player => $dkp) {
			echo "<li>$player's credit... ";
			
			$dkpRounded = round($dkp / ($MIN_DKP_INCREMENT * $DKP_PER_HOUR[$instanceName])) * $MIN_DKP_INCREMENT * $DKP_PER_HOUR[$instanceName];
			if ($dkpRounded == 0) continue;
			/* First we determine a unique ID for the new entry. */

			$result = pg_query($db, "SELECT MAX(change_id) FROM DKP;");
			if (!$result) { echo "  </ul>\n<p class\"error\">Could not obtain a unique change ID: " . pg_last_error($db); require 'footer.php'; exit; }
			if (pg_num_rows($result)) {
				// if there is at least one entry, the unique ID is 1 + the highest existing ID
				$row = pg_fetch_row($result);
				if ($row[0] == NULL) $changeID = 0; // otherwise start at zero
				else $changeID = $row[0] + 1;
			}
			else { echo "  </ul>\n<p class\"error\">Querying the maximum change_id for DKP unexpectedly returned no rows.</p>\n"; rollback($db); require 'footer.php'; exit; }

			/* Create an entry in the Players table if we need to. */

			$result = pg_query($db, "SELECT name FROM Players WHERE name='" . pg_escape_string($player) . "';");
			if (!$result) { echo "  </ul>\n<p class=\"error\">Could not check if a player already existed: " . pg_last_error($db); require 'footer.php'; exit; }
			if (pg_num_rows($result) == 0) {
				$result = pg_query($db, "INSERT INTO Players (name, active) VALUES ('" . pg_escape_string($player) . "', FALSE);");
				if (!$result) { echo "  </ul>\n<p class=\"error\">Could not add an inactive player: " . pg_last_error($db); require 'footer.php'; exit; }
			}
			
			/* Now insert the DKP credit into the DKP table. */

			$query = "INSERT INTO DKP (change_id,raid_id,amount,name) VALUES (" . pg_escape_string($changeID) . "," . pg_escape_string($raidID) . "," . pg_escape_string($dkpRounded) . ",'" . pg_escape_string($player) . "');";
			$result = pg_query($db, $query);
			if (!$result) { echo "  </ul>\n<p class=\"error\">Could not insert a new DKP entry for the credit: " . pg_last_error($db); require 'footer.php'; exit; } 

			if (!fwrite($logFile, "$player RECORD $dkpRounded ($dkp)\n")) { echo "  </ul>\n<p class=\"error\">Could not write to the log file.<\p>\n"; rollback($db); require 'footer.php'; exit; }
			echo "done</li>\n";
		}
		
		echo "</ul>
			<li class=\"announce\">The $instanceDate $instanceName run has been added.  <b>Please <a href=\"index.php?show=raid&id=$raidID\">double-check the raid</a> for sanity!</b></li>\n</ul>\n";

		if (!fclose($logFile)) { echo "  </ul>\n<p class=\"error\">Could not close the log file $logFileName.<\p>\n"; rollback($db); require 'footer.php'; exit; }
		if (!rename($logFileName, "lua-logs/$raidID.log")) { echo "  </ul>\n<p class=\"error\">Could not rename the log file $logFileName.<\p>\n"; rollback($db); require 'footer.php'; exit; }
	}
}

commit($db);

echo "  </ul>
<p>All raids added successfully! Please check each one to make sure it looks good, then you're done!</p>
<p class=\"goback\">Return to the <a href=\"index.php?show=raids\">Raid List</a>.</p>\n";

/* Remove the temp files we uploaded 3 PHP scripts ago. */
foreach (glob("lua-files/*") as $filename) {
	unlink ($filename);
}

require 'footer.php';
?>
