<?php
require 'constants.php';
require 'header.php';

echo "  <h1>Administrator: Add Raid From File</h1>\n";

$filename = 'lua-files/' . date('YmdHis');
if (!move_uploaded_file($_FILES['dkpfile']['tmp_name'], $filename)) {
	echo "<p class=\"error\">Failed to upload LUA file.</p>\n";
	require 'footer.php';
	exit;
}

$luaString = file($filename);
$luaObject = lua2php($luaString);

echo "  <p>Below is a list of raids found in the RS_DKP.lua file you uploaded. Check the ones you want to add to the DKP site. (Perhaps you should <a href=\"index.php?show=raids\">take a look at the raid list</a> first to see if your raid hasn't already been added?) Once you've done that, enter the administrator password and continue to the final step.</p>
<p>Please choose notes that <b>uniquely identify</b> each raid.</p>
<form method=\"post\" action=\"lua-addraid.php\">
<input type=\"hidden\" name=\"lua-data\" value=\"" . urlencode(serialize($luaObject['omgp_raidHistory'])) . "\" />
<table>
<tr>
<th>Import</th>
<th>Date</th>
<th>Instance</th>
<th>Note</th>
</tr>\n";

$isOdd = true;
foreach ($luaObject['omgp_raidHistory'] as $currentRaid) {
	if ($isOdd) { echo "      <tr class=\"odd\">\n"; }
	else { echo "      <tr class=\"even\">\n"; }
	echo "        <td class=\"centered\"><input type=\"checkbox\" name=\"include-" . $currentRaid[1]['time'] . "\" /></td>
		<td>" . date('M j, g:ia', strtotime($currentRaid[1]['time'])) . "</td>
		<td>" . $currentRaid[1]['data']['instance'] . "</td>
		<td><input type=\"textfield\" name=\"note-" . $currentRaid[1]['time'] . "\" /></td>
		</tr>";
	$isOdd = !$isOdd;
}

echo "  </table>
<p class=\"admin\">Enter the administrator password <input type=\"password\" name=\"password\" /> to <input type=\"submit\" name=\"submit\" value=\"Add the Raid\"/>.</p>
<p class=\"goback\">Return to the <a href=\"index.php\">Player List</a>.</p>\n";

require 'footer.php';

function lua2php($luaLinesArray)
{
	$stack = array(array("", array()));
	$stack_pos = 0;
	$last_line = "";
	foreach( $luaLinesArray as $line )
	{
		if(substr( $line, -2, 1 ) == '\\')
		{
			$last_line .= substr($line, 0, -2) . "\n";
			continue;
		}
		$line = $last_line . $line;
		$last_line = "";
		if(strstr( $line, "=" ))
		{
			list($name, $value) = explode("=", $line, 2);
			$name = preg_replace( "/^\s*/","", $name);
			$name = preg_replace( "/\s*$/","", $name);
			if(substr($name,0,2) == "[\"")
			{
				$name = substr($name, 2, -2);
			}
			elseif(substr($name, 0, 1) == "[")
			{
				$name = intval(substr($name, 1, -1));
			}
			$name = trim($name, chr(0xEF).chr(0xBB).chr(0xBF));
			$name = utf8_decode($name);
			$value = preg_replace("/^\s*/", "", $value);
			$value = preg_replace("/\s*$/", "", $value);
			if($value == "{")
			{
				$stack_pos++;
				$stack[$stack_pos] = array($name, array());
			}
			else
			{
				if(preg_match("/^\"([^\"\\\\]|\\\\.)*\"/", $value, $matches))
				{
					$value = substr($matches[0],1,-1);
					$value = preg_replace("/\\\\(.)/", "\\1", $value);
				}
				elseif(preg_match("/([0-9\.]*)e\+([0-9]+)/", $value, $matches))
				{
					$value = floatval($matches[0]);
				}
				elseif(preg_match("/^-?[0-9]+\\.[0-9]+/", $value, $matches))
				{
					$value = floatval($matches[0]);
				}
				elseif(preg_match("/^-?[0-9+]+/", $value, $matches))
				{
					$value = intval($matches[0]);
				}
				elseif(preg_match("/^(True|False)/", $value, $matches))
				{
					if($matches[0] == "True")
					{
						$value = True;
					}
					else
					{
						$value = False;
					}
				}
				elseif(preg_match("/^nil/", $value))
				{
					$value = NULL;
				}
				$value = utf8_decode($value);
				$stack[$stack_pos][1][$name] = $value;
			}
		}
		elseif(preg_match("/^\s*}/", $line))
		{
			$hash = $stack[$stack_pos];
			$stack_pos--;
			$stack[$stack_pos][1][$hash[0]] = $hash[1];
		}
	}
	return $stack[0][1];
}
?>
