<?php
require 'constants.php';
require 'header.php';

echo "  <h1>Administrator: Download DKP Information to WoW</h1>\n";

$query = "SELECT P.name, SUM(CASE WHEN B.item IS NULL THEN D.amount ELSE D.amount*-1 END) AS total FROM Players P, Raids R, DKP D LEFT JOIN Bids AS B ON B.change_id = D.change_id WHERE D.name=P.name AND D.raid_id = R.raid_id GROUP BY P.name ORDER BY P.name;";
$result = pg_query($db, $query);
if (!$result) { echo "  <p class=\"error\">Couldn't get current DKP standings: " . pg_last_error($db) . "</p>\n"; require 'footer.php'; exit; }

$dkpAsLua = "--------------------------------------------------------------------------------
-- Oops!  Hit the Back button on your browser, go to the download link again, --
-- but this time right-click the link and choose \"Save to File\" (or           --
-- something like that).                                                      --
--------------------------------------------------------------------------------

omgp_playerDKP = {\n";
	while ($row = pg_fetch_row($result)) {
		$dkpAsLua .= "\t[\"" . strtoupper($row[0]) . "\"] = $row[1],\n";
	}
	$dkpAsLua .= "\t[1] = 0\n}\n";

	$dkpInfoFileName = 'RS_DKP.lua';
	if (!$fileHandle = fopen($dkpInfoFileName, 'w')) {
		echo "<p class=\"error\">Couldn't create RS_DKP.lua file on server.</p>\n";
		require 'footer.php';
		exit;
	}
	if (!fwrite($fileHandle, $dkpAsLua)) {
		echo "<p class=\"error\">Couldn't write Lua data to RS_DKP.lua file on server.</p>\n";
		require 'footer.php';
		exit;
	}

	echo "  <p>To synchronize current DKP with your copy of World of Warcraft, please <a href=\"lua-send.php\">download this <b>RS_DKP.lua</b> file</a> (if that download doesn't work then try <a href=\"RS_DKP.lua\">this one</a>) and place it in the following directory: <i>[your World of Warcraft directory] &gt; WTF &gt; Account &gt; [your account name] &gt; SavedVariables</i>. You can overwrite the existing RS_DKP.lua file.</p>
		<p><b>Do not replace your RS_DKP.lua file if you have raids you still need to upload.</b> Your RS_DKP.lua file also contains how much DKP everyone earned for the last few raids. If you replace it with this brand new RS_DKP.lua file without first uploading those raids, they will be gone forever. You can always check to see if you have any raids you still need to upload by <a href=\"lua-choosefile.php\">uploading your current RS_DKP.lua file</a>.</p>
		<p class=\"goback\">Return to the <a href=\"index.php\">DKP Listings</a> web page.</p>\n\n";

	require 'footer.php';
	?>
