--
-- RETIRED SQUIRRELS DKP MANAGER
-- Database structure
--
-- This file will destroy any existing DKP information
-- when used with your DKP database.
--

BEGIN;

-- Table structure for table Classes

CREATE TABLE Classes (
  class CHARACTER VARYING(7) NOT NULL,
  PRIMARY KEY(class)
);

-- Table data for table Classes

INSERT INTO Classes VALUES ('Druid');
INSERT INTO Classes VALUES ('Hunter');
INSERT INTO Classes VALUES ('Mage');
INSERT INTO Classes VALUES ('Paladin');
INSERT INTO Classes VALUES ('Priest');
INSERT INTO Classes VALUES ('Rogue');
INSERT INTO Classes VALUES ('Shaman');
INSERT INTO Classes VALUES ('Warlock');
INSERT INTO Classes VALUES ('Warrior');

-- Table structure for table Sets

CREATE TABLE Sets (
	id SMALLINT NOT NULL,
	name CHARACTER VARYING(100) NOT NULL,
	class CHARACTER VARYING(7),
	tier SMALLINT,
	PRIMARY KEY(id),
	FOREIGN KEY(class) REFERENCES Classes ON DELETE RESTRICT
);

-- Table data for table Sets

INSERT INTO Sets VALUES (0, 'None', NULL, NULL);

INSERT INTO Sets VALUES (1, 'Cenarion Raiment', 'Druid', 1);
INSERT INTO Sets VALUES (2, 'Giantstalker Armor', 'Hunter', 1);
INSERT INTO Sets VALUES (3, 'Arcanist Regalia', 'Mage', 1);
INSERT INTO Sets VALUES (4, 'Lawbringer Armor', 'Paladin', 1);
INSERT INTO Sets VALUES (5, 'Vestments of Prophecy', 'Priest', 1);
INSERT INTO Sets VALUES (6, 'Nightslayer Armor', 'Rogue', 1);
INSERT INTO Sets VALUES (7, 'The Earthfury', 'Shaman', 1);
INSERT INTO Sets VALUES (8, 'Felheart Raiment', 'Warlock', 1);
INSERT INTO Sets VALUES (9, 'Battlegear of Might', 'Warrior', 1);

INSERT INTO Sets VALUES (10, 'Stormrage Raiment', 'Druid', 2);
INSERT INTO Sets VALUES (11, 'Dragonstalker Armor', 'Hunter', 2);
INSERT INTO Sets VALUES (12, 'Netherwind Regalia', 'Mage', 2);
INSERT INTO Sets VALUES (13, 'Judgement Armor', 'Paladin', 2);
INSERT INTO Sets VALUES (14, 'Vestments of Transcendence', 'Priest', 2);
INSERT INTO Sets VALUES (15, 'Bloodfang Armor', 'Rogue', 2);
INSERT INTO Sets VALUES (16, 'The Ten Storms', 'Shaman', 2);
INSERT INTO Sets VALUES (17, 'Nemesis Raiment', 'Warlock', 2);
INSERT INTO Sets VALUES (18, 'Battlegear of Wrath', 'Warrior', 2);

/*INSERT INTO Sets VALUES (19, 'Dreamwalker Raiment', 'Druid', 3);
INSERT INTO Sets VALUES (20, 'Cryptstalker Armor', 'Hunter', 3);
INSERT INTO Sets VALUES (21, 'Frostfire Regalia', 'Mage', 3);
INSERT INTO Sets VALUES (22, 'Redemption Armor', 'Paladin', 3);
INSERT INTO Sets VALUES (23, 'Vestments of Faith', 'Priest', 3);
INSERT INTO Sets VALUES (24, 'Bonescythe Armor', 'Rogue', 3);
INSERT INTO Sets VALUES (25, 'The Earthshatterer', 'Shaman', 3);
INSERT INTO Sets VALUES (26, 'Plagueheart Raiment', 'Warlock', 3);
INSERT INTO Sets VALUES (27, 'Dreadnaught\'s Battlegear', 'Warrior', 3);*/

-- Table structure for table Items

CREATE TABLE Items (
  item CHARACTER VARYING(64) NOT NULL,
  url CHARACTER VARYING(255) DEFAULT NULL,
  set_id SMALLINT DEFAULT 0,
  PRIMARY KEY(item),
  FOREIGN KEY(set_id) REFERENCES Sets(id) ON DELETE SET DEFAULT
);

-- Table data for table Items

INSERT INTO Items VALUES ('Cenarion Belt', 'http://www.thottbot.com/?i=26495', 1);
INSERT INTO Items VALUES ('Cenarion Boots', 'http://www.thottbot.com/?i=27204', 1);
INSERT INTO Items VALUES ('Cenarion Bracers', 'http://www.thottbot.com/?i=26155', 1);
INSERT INTO Items VALUES ('Cenarion Gloves', 'http://www.thottbot.com/?i=27124', 1);
INSERT INTO Items VALUES ('Cenarion Helm', 'http://www.thottbot.com/?i=28155', 1);
INSERT INTO Items VALUES ('Cenarion Leggings', 'http://www.thottbot.com/?i=27475', 1);
INSERT INTO Items VALUES ('Cenarion Spaulders', 'http://www.thottbot.com/?i=27744', 1);
INSERT INTO Items VALUES ('Cenarion Vestments', 'http://www.thottbot.com/?i=37303', 1);

INSERT INTO Items VALUES ('Giantstalker\'s Belt', 'http://www.thottbot.com/?i=27034', 2);
INSERT INTO Items VALUES ('Giantstalker\'s Boots', 'http://www.thottbot.com/?i=37286', 2);
INSERT INTO Items VALUES ('Giantstalker\'s Bracers', 'http://www.thottbot.com/?i=25216', 2);
INSERT INTO Items VALUES ('Giantstalker\'s Breastplate', 'http://www.thottbot.com/?i=27627', 2);
INSERT INTO Items VALUES ('Giantstalker\'s Epaulets', 'http://www.thottbot.com/?i=27742', 2);
INSERT INTO Items VALUES ('Giantstalker\'s Gloves', 'http://www.thottbot.com/?i=37369', 2);
INSERT INTO Items VALUES ('Giantstalker\'s Helmet', 'http://www.thottbot.com/?i=37439', 2);
INSERT INTO Items VALUES ('Giantstalker\'s Leggings', 'http://www.thottbot.com/?i=27554', 2);

INSERT INTO Items VALUES ('Arcanist Belt', 'http://www.thottbot.com/?i=27040', 3);
INSERT INTO Items VALUES ('Arcanist Bindings', 'http://www.thottbot.com/?i=26877', 3);
INSERT INTO Items VALUES ('Arcanist Boots', 'http://www.thottbot.com/?i=36042', 3);
INSERT INTO Items VALUES ('Arcanist Crown', 'http://www.thottbot.com/?i=37308', 3);
INSERT INTO Items VALUES ('Arcanist Gloves', 'http://www.thottbot.com/?i=27514', 3);
INSERT INTO Items VALUES ('Arcanist Leggings', 'http://www.thottbot.com/?i=37434', 3);
INSERT INTO Items VALUES ('Arcanist Mantle', 'http://www.thottbot.com/?i=37367', 3);
INSERT INTO Items VALUES ('Arcanist Robes', 'http://www.thottbot.com/?i=27157', 3);

INSERT INTO Items VALUES ('Lawbringer Belt', 'http://www.thottbot.com/?i=27084', 4);
INSERT INTO Items VALUES ('Lawbringer Boots', 'http://www.thottbot.com/?i=27445', 4);
INSERT INTO Items VALUES ('Lawbringer Bracers', 'http://www.thottbot.com/?i=26863', 4);
INSERT INTO Items VALUES ('Lawbringer Chestguard', 'http://www.thottbot.com/?i=37720', 4);
INSERT INTO Items VALUES ('Lawbringer Gauntlets', 'http://www.thottbot.com/?i=28178', 4);
INSERT INTO Items VALUES ('Lawbringer Helm', 'http://www.thottbot.com/?i=28234', 4);
INSERT INTO Items VALUES ('Lawbringer Legplates', 'http://www.thottbot.com/?i=36347', 4);
INSERT INTO Items VALUES ('Lawbringer Spaulders', 'http://www.thottbot.com/?i=37730', 4);

INSERT INTO Items VALUES ('Boots of Prophecy', 'http://www.thottbot.com/?i=27038', 5);
INSERT INTO Items VALUES ('Circlet of Prophecy', 'http://www.thottbot.com/?i=37373', 5);
INSERT INTO Items VALUES ('Girdle of Prophecy', 'http://www.thottbot.com/?i=27056', 5);
INSERT INTO Items VALUES ('Gloves of Prophecy', 'http://www.thottbot.com/?i=27493', 5);
INSERT INTO Items VALUES ('Mantle of Prophecy', 'http://www.thottbot.com/?i=27135', 5);
INSERT INTO Items VALUES ('Pants of Prophecy', 'http://www.thottbot.com/?i=36486', 5);
INSERT INTO Items VALUES ('Robes of Prophecy', 'http://www.thottbot.com/?i=27456', 5);
INSERT INTO Items VALUES ('Vambraces of Prophecy', 'http://www.thottbot.com/?i=26619', 5);

INSERT INTO Items VALUES ('Nightslayer Belt', 'http://www.thottbot.com/?i=26074', 6);
INSERT INTO Items VALUES ('Nightslayer Boots', 'http://www.thottbot.com/?i=37368', 6);
INSERT INTO Items VALUES ('Nightslayer Bracelets', 'http://www.thottbot.com/?i=26256', 6);
INSERT INTO Items VALUES ('Nightslayer Chestpiece', 'http://www.thottbot.com/?i=39997', 6);
INSERT INTO Items VALUES ('Nightslayer Cover', 'http://www.thottbot.com/?i=27293', 6);
INSERT INTO Items VALUES ('Nightslayer Gloves', 'http://www.thottbot.com/?i=27367', 6);
INSERT INTO Items VALUES ('Nightslayer Pants', 'http://www.thottbot.com/?i=38448', 6);
INSERT INTO Items VALUES ('Nightslayer Shoulder Pads', 'http://www.thottbot.com/?i=27073', 6);

INSERT INTO Items VALUES ('Earthfury Belt', 'http://www.thottbot.com/?i=27188', 7);
INSERT INTO Items VALUES ('Earthfury Boots', 'http://www.thottbot.com/?i=27745', 7);
INSERT INTO Items VALUES ('Earthfury Bracers', 'http://www.thottbot.com/?i=27099', 7);
INSERT INTO Items VALUES ('Earthfury Epaulets', 'http://www.thottbot.com/?i=37342', 7);
INSERT INTO Items VALUES ('Earthfury Gauntlets', 'http://www.thottbot.com/?i=27327', 7);
INSERT INTO Items VALUES ('Earthfury Helmet', 'http://www.thottbot.com/?i=28096', 7);
INSERT INTO Items VALUES ('Earthfury Legguards', 'http://www.thottbot.com/?i=27609', 7);
INSERT INTO Items VALUES ('Earthfury Vestments', 'http://www.thottbot.com/?i=27065', 7);

INSERT INTO Items VALUES ('Felheart Belt', 'http://www.thottbot.com/?i=26683', 8);
INSERT INTO Items VALUES ('Felheart Bracers', 'http://www.thottbot.com/?i=25816', 8);
INSERT INTO Items VALUES ('Felheart Gloves', 'http://www.thottbot.com/?i=27303', 8);
INSERT INTO Items VALUES ('Felheart Horns', 'http://www.thottbot.com/?i=28095', 8);
INSERT INTO Items VALUES ('Felheart Pants', 'http://www.thottbot.com/?i=37441', 8);
INSERT INTO Items VALUES ('Felheart Robes', 'http://www.thottbot.com/?i=37318', 8);
INSERT INTO Items VALUES ('Felheart Shoulder Pads', 'http://www.thottbot.com/?i=27184', 8);
INSERT INTO Items VALUES ('Felheart Slippers', 'http://www.thottbot.com/?i=35833', 8);

INSERT INTO Items VALUES ('Belt of Might', 'http://www.thottbot.com/?i=26806', 9);
INSERT INTO Items VALUES ('Bracers of Might', 'http://www.thottbot.com/?i=27037', 9);
INSERT INTO Items VALUES ('Breastplate of Might', 'http://www.thottbot.com/?i=27194', 9);
INSERT INTO Items VALUES ('Gauntlets of Might', 'http://www.thottbot.com/?i=37316', 9);
INSERT INTO Items VALUES ('Helm of Might', 'http://www.thottbot.com/?i=37534', 9);
INSERT INTO Items VALUES ('Legplates of Might', 'http://www.thottbot.com/?i=27519', 9);
INSERT INTO Items VALUES ('Pauldrons of Might', 'http://www.thottbot.com/?i=26588', 9);
INSERT INTO Items VALUES ('Sabatons of Might', 'http://www.thottbot.com/?i=27205', 9);

INSERT INTO Items VALUES ('Stormrage Belt', 'http://www.thottbot.com/?i=40792', 10);
INSERT INTO Items VALUES ('Stormrage Boots', 'http://www.thottbot.com/?i=36980', 10);
INSERT INTO Items VALUES ('Stormrage Bracers', 'http://www.thottbot.com/?i=40039', 10);
INSERT INTO Items VALUES ('Stormrage Cover', 'http://www.thottbot.com/?i=27628', 10);
INSERT INTO Items VALUES ('Stormrage Legguards', 'http://www.thottbot.com/?i=38128', 10);
INSERT INTO Items VALUES ('Stormrage Chestguard', 'http://www.thottbot.com/?i=38269', 10);
INSERT INTO Items VALUES ('Stormrage Pauldrons', 'http://www.thottbot.com/?i=35684', 10);

INSERT INTO Items VALUES ('Dragonstalker\'s Belt', 'http://www.thottbot.com/?i=27206', 11);
INSERT INTO Items VALUES ('Dragonstalker\'s Bracers', 'http://www.thottbot.com/?i=40739', 11);
INSERT INTO Items VALUES ('Dragonstalker\'s Greaves', 'http://www.thottbot.com/?i=36702', 11);
INSERT INTO Items VALUES ('Dragonstalker\'s Helm', 'http://www.thottbot.com/?i=27520', 11);
INSERT INTO Items VALUES ('Dragonstalker\'s Breastplate', 'http://www.thottbot.com/?i=51918', 11);
INSERT INTO Items VALUES ('Dragonstalker\'s Gauntlets', 'http://www.thottbot.com/?i=35570', 11);
INSERT INTO Items VALUES ('Dragonstalker\'s Legguards', 'http://www.thottbot.com/?i=37611', 11);
INSERT INTO Items VALUES ('Dragonstalker\'s Spaulders', 'http://www.thottbot.com/?i=36293', 11);

INSERT INTO Items VALUES ('Netherwind Belt', 'http://www.thottbot.com/?i=27687', 12);
INSERT INTO Items VALUES ('Netherwind Bindings', 'http://www.thottbot.com/?i=38374', 12);
INSERT INTO Items VALUES ('Netherwind Crown', 'http://www.thottbot.com/?i=27679', 12);
INSERT INTO Items VALUES ('Netherwind Gloves', 'http://www.thottbot.com/?i=37347', 12);
INSERT INTO Items VALUES ('Netherwind Pants', 'http://www.thottbot.com/?i=37853', 12);
INSERT INTO Items VALUES ('Netherwind Boots', 'http://www.thottbot.com/?i=38373', 12);
INSERT INTO Items VALUES ('Netherwind Mantle', 'http://www.thottbot.com/?i=28036', 12);
INSERT INTO Items VALUES ('Netherwind Robes', 'http://www.thottbot.com/?i=38375', 12);

INSERT INTO Items VALUES ('Judgement Belt', 'http://www.thottbot.com/?i=27163', 13);
INSERT INTO Items VALUES ('Judgement Bindings', 'http://www.thottbot.com/?i=27492', 13);
INSERT INTO Items VALUES ('Judgement Breastplate', 'http://www.thottbot.com/?i=37867', 13);
INSERT INTO Items VALUES ('Judgement Crown', 'http://www.thottbot.com/?i=27290', 13);
INSERT INTO Items VALUES ('Judgement Gauntlets', 'http://www.thottbot.com/?i=37889', 13);
INSERT INTO Items VALUES ('Judgement Legplates', 'http://www.thottbot.com/?i=37869', 13);
INSERT INTO Items VALUES ('Judgement Sabatons', 'http://www.thottbot.com/?i=27927', 13);
INSERT INTO Items VALUES ('Judgement Spaulders', 'http://www.thottbot.com/?i=37868', 13);

INSERT INTO Items VALUES ('Belt of Transcendence', 'http://www.thottbot.com/?i=27861', 14);
INSERT INTO Items VALUES ('Bindings of Transcendence', 'http://www.thottbot.com/?i=27593', 14);
INSERT INTO Items VALUES ('Halo of Transcendence', 'http://www.thottbot.com/?i=26965', 14);
INSERT INTO Items VALUES ('Leggings of Transcendence', 'http://www.thottbot.com/?i=37699', 14);
INSERT INTO Items VALUES ('Boots of Transcendence', 'http://www.thottbot.com/?i=27394', 14);
INSERT INTO Items VALUES ('Handguards of Transcendence', 'http://www.thottbot.com/?i=27328', 14);
INSERT INTO Items VALUES ('Pauldrons of Transcendence', 'http://www.thottbot.com/?i=38295', 14);
INSERT INTO Items VALUES ('Robes of Transcendence', 'http://www.thottbot.com/?i=38296', 14);

INSERT INTO Items VALUES ('Bloodfang Belt', 'http://www.thottbot.com/?i=27137', 15);
INSERT INTO Items VALUES ('Bloodfang Boots', 'http://www.thottbot.com/?i=27566', 15);
INSERT INTO Items VALUES ('Bloodfang Hood', 'http://www.thottbot.com/?i=28223', 15);
INSERT INTO Items VALUES ('Bloodfang Pants', 'http://www.thottbot.com/?i=36929', 15);
INSERT INTO Items VALUES ('Bloodfang Bracers', 'http://www.thottbot.com/?i=27594', 15);
INSERT INTO Items VALUES ('Bloodfang Chestpiece', 'http://www.thottbot.com/?i=36928', 15);
INSERT INTO Items VALUES ('Bloodfang Gloves', 'http://www.thottbot.com/?i=27183', 15);
INSERT INTO Items VALUES ('Bloodfang Spaulders', 'http://www.thottbot.com/?i=36327', 15);

INSERT INTO Items VALUES ('Belt of Ten Storms', 'http://www.thottbot.com/?i=27329', 16);
INSERT INTO Items VALUES ('Bracers of Ten Storms', 'http://www.thottbot.com/?i=27330', 16);
INSERT INTO Items VALUES ('Helmet of Ten Storms', 'http://www.thottbot.com/?i=36674', 16);
INSERT INTO Items VALUES ('Legplates of Ten Storms', 'http://www.thottbot.com/?i=40031', 16);
INSERT INTO Items VALUES ('Breastplate of Ten Storms', 'http://www.thottbot.com/?i=40210', 16);
INSERT INTO Items VALUES ('Epaulets of Ten Storms', 'http://www.thottbot.com/?i=40209', 16);
INSERT INTO Items VALUES ('Gauntlets of Ten Storms', 'http://www.thottbot.com/?i=40211', 16);
INSERT INTO Items VALUES ('Greaves of Ten Storms', 'http://www.thottbot.com/?i=27850', 16);

INSERT INTO Items VALUES ('Nemesis Boots', 'http://www.thottbot.com/?i=38354', 17);
INSERT INTO Items VALUES ('Nemesis Bracers', 'http://www.thottbot.com/?i=27588', 17);
INSERT INTO Items VALUES ('Nemesis Leggings', 'http://www.thottbot.com/?i=37836', 17);
INSERT INTO Items VALUES ('Nemesis Skullcap', 'http://www.thottbot.com/?i=27211', 17);
INSERT INTO Items VALUES ('Nemesis Belt', 'http://www.thottbot.com/?i=38355', 17);
INSERT INTO Items VALUES ('Nemesis Gloves', 'http://www.thottbot.com/?i=27656', 17);
INSERT INTO Items VALUES ('Nemesis Robes', 'http://www.thottbot.com/?i=38356', 17);
INSERT INTO Items VALUES ('Nemesis Spaulders', 'http://www.thottbot.com/?i=27331', 17);

INSERT INTO Items VALUES ('Bracelets of Wrath', 'http://www.thottbot.com/?i=27138', 18);
INSERT INTO Items VALUES ('Helm of Wrath', 'http://www.thottbot.com/?i=27583', 18);
INSERT INTO Items VALUES ('Legplates of Wrath', 'http://www.thottbot.com/?i=37588', 18);
INSERT INTO Items VALUES ('Sabatons of Wrath', 'http://www.thottbot.com/?i=27210', 18);
INSERT INTO Items VALUES ('Breastplate of Wrath', 'http://www.thottbot.com/?i=37871', 18);
INSERT INTO Items VALUES ('Gauntlets of Wrath', 'http://www.thottbot.com/?i=27772', 18);
INSERT INTO Items VALUES ('Pauldrons of Wrath', 'http://www.thottbot.com/?i=37874', 18);
INSERT INTO Items VALUES ('Waistband of Wrath', 'http://www.thottbot.com/?i=28106', 18);

-- Table structure for table Players

CREATE TABLE Players (
  name CHARACTER VARYING(16) NOT NULL,
  class CHARACTER VARYING(7) DEFAULT NULL,
  active BOOLEAN NOT NULL DEFAULT TRUE,
  PRIMARY KEY(name),
  FOREIGN KEY(class) REFERENCES Classes ON DELETE RESTRICT
);

-- Table structure for table Instances

CREATE TABLE Instances (
  instance CHARACTER VARYING(20) NOT NULL,
  PRIMARY KEY(instance)
);

-- Table data for table Instances

INSERT INTO Instances VALUES ('Azuregos');
INSERT INTO Instances VALUES ('Blackwing Lair');
INSERT INTO Instances VALUES ('Correction Entry');
INSERT INTO Instances VALUES ('Emeriss');
INSERT INTO Instances VALUES ('Kazzak');
INSERT INTO Instances VALUES ('Lethon');
INSERT INTO Instances VALUES ('Molten Core');
INSERT INTO Instances VALUES ('Naxxramas');
INSERT INTO Instances VALUES ('Onyxia\'s Lair');
INSERT INTO Instances VALUES ('Taerar');
INSERT INTO Instances VALUES ('Temple of Ahn\'Qiraj');
INSERT INTO Instances VALUES ('Ysondre');

-- Table structure for table Raids

CREATE TABLE Raids (
  raid_id INTEGER NOT NULL,
  instance CHARACTER VARYING(20) NOT NULL,
  date DATE NOT NULL DEFAULT '1904-01-01',
  note CHARACTER VARYING(64) DEFAULT NULL,
  PRIMARY KEY(raid_id),
  FOREIGN KEY(instance) REFERENCES Instances ON DELETE RESTRICT
);

-- Table structure for table DKP

CREATE TABLE DKP (
  change_id INTEGER NOT NULL,
  raid_id INTEGER NOT NULL,
  name CHARACTER VARYING(16) NOT NULL DEFAULT '',
  amount DECIMAL(4,1) NOT NULL DEFAULT 0,
  PRIMARY KEY(change_id),
  FOREIGN KEY(raid_id) REFERENCES Raids ON DELETE CASCADE,
  FOREIGN KEY(name) REFERENCES Players ON DELETE CASCADE
);

-- Table structure for table Bids

CREATE TABLE Bids (
  change_id INTEGER NOT NULL,
  item CHARACTER VARYING(64) NOT NULL,
  PRIMARY KEY(change_id),
  FOREIGN KEY(item) REFERENCES Items ON DELETE RESTRICT
);

-- Table structure for table Passwords

CREATE TABLE Passwords (
    password CHARACTER VARYING(64) NOT NULL,
    manage_members BOOLEAN NOT NULL DEFAULT FALSE,
    manage_dkp BOOLEAN NOT NULL DEFAULT FALSE,
    PRIMARY KEY(password)
);

INSERT INTO Passwords VALUES ('dkp_password', TRUE, TRUE);

COMMIT;
