<?php
require 'constants.php';
require 'header.php';
?>
<h1>The Mechanics of DKP</h1>
<h2>Summary</h2>
<p>Dragon Kill Points (DKP) is a system to allocate useful end-game instance drops to raid participants based on their contribution to past raids. DKP is earned by attending raids, and then bid on items the player desires in public auctions.</p>
<p>DKP is earned for every thirty minutes of raid participation. The smallest DKP increment that can be earned or spent is 0.5. DKP is not earned if the player is not actively participating in the raid. DKP is awarded to every player present for a boss kill. DKP is also awarded to every player who is ready to raid at the beginning of the raid.</p>
<p>DKP is spent in public, anonymous auctions lasting until 20 seconds pass after a bid. Players are allowed to change or withdraw their bids during this period, but cannot know other players' bids. At the end of the auction the item is given to the player with the highest bid. Players cannot win items if they do not have their Onyxia key or have outstanding debt to the guild.</p>
<p>Please visit the <a href="http://www.incpwns.com/guild-policies">Guild Policies</a>  page for a formal overview of our DKP system, and the <a href="http://www.incpwns.com/dkp-values">DKP Values</a> page for up-to-date DKP values for time spent raiding, boss kills, and ontime bonuses.</p>
<h3>Frequently Asked Questions</h3>
<p><b>When I bid on an item in a raid, can I use the DKP that I've earned so far in that raid?</b><br />
No. DKP is not available until it has been calculated by an officer after the raid.</p>
<p><b>Can I bid my DKP for a bind-on-equip item that I give to someone else?</b><br />
No. All items a player wins go only to that player.</p>
<p><b>Can I bid for someone in absentia?</b><br />
No. Players can only bid their own DKP, and can only receive items for themselves.</p>
<p><b>What is the minimum bid?</b><br />
Four DKP.</p>
<p><b>Can I bid on any old item, even if I don't need it?</b><br />
You can only bid on items that a) your class can equip, and b) you would gain some utilization from wearing, outside of the utilization you get from simply owning it. (That is to say, it has to have at least some value to you other than sitting in your inventory, where it might just become future gold coins.)</p>
<p><b>So say a mace drops that does +80 to healing spells, and also has a single point of strength. Obviously this mace is meant for a priest. But since it has a single point of strength, does that mean a warrior could bid on it too?</b><br />
Yes. You must trust that the priest will bid more than the warrior, if the warrior even bids at all. There are occasionally situations where this is not the case; however, this has thusfar proven to be rare.</p>
<p><b>What happens if there is a tie?</b><br />
A rebid is taken between the people involved in the tie. The new minimum bid for the rebid is the tie amount -- you cannot bid lower than your previous bid.</p>
<p><b>Can I withdraw my bid during a tie?</b><br />
Yes, but in the event that everyone withdraws, you may be "forced" to win (at officer discretion). Remember, entering a bid is akin to entering a contract saying "I am prepared to pay this amount of DKP." You can't back out. You may get lucky and not have to pay the amount you agreed to, but you can't guarantee that.</p>
<p><b>What about legendary items or recipes?</b><br />
Items that require the effort of the guild to create (such as Sulfuras), or yield more benefit to the guild than to the player (such as recipes), are not a part of the DKP system.</p>
<p><b>Can I change or withdraw my bid?</b><br />
Yes, at any point while bidding is open. Once bidding is closed your last bid is final.</p>
<p><b>What happens if I go in debt?</b><br />
It is your responsibility to ensure you don't overbid. Officers will handle the situation if you do at their discretion.</p>
<p><b>What raids are eligible for DKP? If I start a guild Zul'Gurub raid, do we use DKP?</b><br />
Officers decide which raids are eligible for DKP earning and spending. The raids must be sponsored and run by officers. At this time, only officer-run 40-man raids (like Molten Core) fall under the DKP system. Twenty-man raids like Zul'Gurub are considered player-run.</p>
<p class="goback">Return to the <a href="index.php">Player List</a>.</p>
<?php
require 'footer.php';
?>
