<?php

$sort = 'class';
if (stripslashes($_GET['sort']) == 'player') $sort = 'player';
else if (stripslashes($_GET['sort']) == 'dkp') $sort = 'dkp';

$query = "SELECT P.name, SUM(CASE WHEN B.item IS NULL THEN D.amount ELSE D.amount*-1 END) AS total, P.class FROM Players P, Raids R, DKP D LEFT JOIN Bids AS B ON B.change_id = D.change_id WHERE D.name=P.name AND D.raid_id = R.raid_id AND P.active = TRUE GROUP BY P.name, P.class ";
if ($sort == 'player') $query .= 'ORDER BY P.name ASC;';
else if ($sort == 'dkp') $query .= 'ORDER BY total DESC, P.name ASC;';
else $query .= 'ORDER BY P.class ASC, total DESC, P.name ASC;';

$result = pg_query($db, $query);
if (!$result) { echo "  <p class=\"error\">Couldn't get player information: " . pg_last_error($db) . "</p>\n"; require 'footer.php'; exit; }

echo "
<table>
<tr>\n";
if ($sort == 'player') echo "    <th class=\"primary\">Player</th>\n";
else echo "    <th><a href=\"index.php?sort=player\">Player</a></th>\n";
if ($sort == 'dkp') echo "    <th class=\"primary\">Current DKP</th>\n";
else echo "    <th><a href=\"index.php?sort=dkp\">Current DKP</a></th>\n";
if ($sort == 'class') echo "    <th class=\"primary\">Class</th>\n";
else echo "    <th><a href=\"index.php\">Class</a></th>\n";
echo "</tr>";
while ($row = pg_fetch_row($result)) {
	if ($row[2] == '') $row[2] = 'Unspecified';
	echo "
		<tr class=\"class-" . $row[2] . "\">
		<td class=\"primary\"><a href=\"index.php?show=player&amp;name=$row[0]\">$row[0]</a></td>
		<td class=\"numeric\">$row[1]</td>
		<td>$row[2]</td>
		<!-- <td class=\"numeric\">$row[3]</td> -->
		</tr>";
}
echo "
</table>
<p class=\"note\"><b>Note:</b> If your name is not in this list, you have no DKP to date.</p>
<p>Want to know who's core and who's casual? View <a href=\"index.php?show=stats\">raiding statistics</a>.</p>\n\n";
?>
